package Echiquier.Modele;

import Echiquier.Echiquier;
import Echiquier.Modele.Piece.Piece;

public class Case{
    //le numéro de ligne
    private int lig;
    //le numéro de colonne
    private int col;
    //le piece dans le case
    private Piece piece;

    /**
     *
     * @param lig le numéro de ligne
     * @param col le numéro de colonne
     * @throws Exception le ligne et le colonne ne peut pas au-delà echiquer
     */
    public Case(int lig, int col) throws Exception {
        if(lig < 0 || col < 0 || lig >= Echiquier.MAXLIG || col >= Echiquier.MAXCOL)
            throw new Exception("Le ligne faut entre 1 à " + (Echiquier.MAXLIG - 1) + ", La colonne faut entre 1 à " + (Echiquier.MAXCOL - 1));
        this.lig = lig;
        this.col = col;
    }

    /**
     * Verifier le case a un case ou pas
     * @return true le case a un piece
     */
    public boolean estEuPiece(){
        if(null == piece)
            return false;
        return true;
    }

    public Piece getPiece() {
        return piece;
    }

    public void setPiece(Piece piece) {
        this.piece = piece;
    }

    public int getCol() {
        return col;
    }

    public int getLig() {
        return lig;
    }

    public String toString(){
        return "(" + (Echiquier.MAXLIG - lig) + "," + (char)('A'+ col) + ")";
    }

}
