package Echiquier;

import Echiquier.Modele.Case;
import org.junit.Assert;
import org.junit.Test;

public class EchiquierTest {
    @Test
    public void testEstEnLigne1() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(1,2);
        Case case2 = new Case(5,2);

        Assert.assertTrue(echiquier.estEnLigne(case1,case2));
    }

    @Test
    public void testEstEnLigne2() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(6,3);
        Case case2 = new Case(3,3);

        Assert.assertTrue(echiquier.estEnLigne(case1,case2));
    }

    @Test
    public void testEstEnLigne3() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(7,2);
        Case case2 = new Case(7,4);

        Assert.assertTrue(echiquier.estEnLigne(case1,case2));
    }

    @Test
    public void testEstEnLigne4() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(5,1);
        Case case2 = new Case(5,7);

        Assert.assertTrue(echiquier.estEnLigne(case1,case2));
    }

    @Test
    public void testestEnDiagonales1() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(3,2);
        Case case2 = new Case(2,3);

        Assert.assertTrue(echiquier.estEnDiagonales(case1,case2));
    }

    @Test
    public void testestEnDiagonales2() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(5,3);
        Case case2 = new Case(3,1);

        Assert.assertTrue(echiquier.estEnDiagonales(case1,case2));
    }

    @Test
    public void testestEnDiagonales3() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(4,6);
        Case case2 = new Case(7,3);

        Assert.assertTrue(echiquier.estEnDiagonales(case1,case2));
    }

    @Test
    public void testestEnDiagonales4() throws Exception {
        Echiquier echiquier = new Echiquier();
        Case case1 = new Case(2,3);
        Case case2 = new Case(5,6);

        Assert.assertTrue(echiquier.estEnDiagonales(case1,case2));
    }

    @Test
    public void testDeplace() throws Exception{
        Echiquier echiquier = new Echiquier();

        //BLACHE: test pion permier deplace
        echiquier.deplace(transferer("A2-A4"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("B8-A6"));

        //BLACHE: test pion
        echiquier.deplace(transferer("A4-A5"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("A6-B4"));

        //BLACHE: test tour
        echiquier.deplace(transferer("A1-A3"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("B4-C6"));

        //BLACHE: test tour
        echiquier.deplace(transferer("A3-H3"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("C6-B8"));

        //BLACHE: test tour
        echiquier.deplace(transferer("H3-A3"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("B8-C6"));

        //BLACHE: test tour
        echiquier.deplace(transferer("A3-A1"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("C6-A5"));

        //BLACHE: prepare test
        echiquier.deplace(transferer("D2-D4"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("A5-C4"));

        //BLACHE: test fou
        echiquier.deplace(transferer("C1-F4"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("C4-E5"));

        //BLACHE: test fou
        echiquier.deplace(transferer("F4-D2"));

        //NOIR: test cavailer
        echiquier.deplace(transferer("E5-C6"));

        //BLACHE: test fou
        echiquier.deplace(transferer("D2-A5"));

        //NOIR: prepare test roi
        echiquier.deplace(transferer("E7-E5"));

        //BLACHE: test fou
        echiquier.deplace(transferer("A5-B4"));

        //NOIR: test roi
        echiquier.deplace(transferer("E8-E7"));

        //BLACHE: test dame
        echiquier.deplace(transferer("D1-D3"));

        //NOIR: test roi
        echiquier.deplace(transferer("E7-F6"));

        //BLACHE: test dame
        echiquier.deplace(transferer("D3-A3"));

        //NOIR: test roi
        echiquier.deplace(transferer("F6-E6"));

        //BLACHE: test dame
        echiquier.deplace(transferer("A3-D3"));

        //NOIR: test roi
        echiquier.deplace(transferer("E6-F6"));

        //BLACHE: test dame
        echiquier.deplace(transferer("D3-D2"));

        //NOIR: test roi
        echiquier.deplace(transferer("F6-E7"));

        //BLACHE: test dame
        echiquier.deplace(transferer("D2-C3"));

        //NOIR: test roi
        echiquier.deplace(transferer("E7-D6"));

        //BLACHE: test dame
        echiquier.deplace(transferer("C3-D2"));

        //NOIR: test roi
        echiquier.deplace(transferer("D6-E7"));

        //BLACHE: test dame
        echiquier.deplace(transferer("D2-G5"));

        //NOIR: test roi
        echiquier.deplace(transferer("E7-E8"));

        //BLACHE: test dame
        echiquier.deplace(transferer("G5-D2"));

        //NOIR: pass
        echiquier.deplace(transferer("E8-E7"));

        //BLACHE: test dame
        echiquier.deplace(transferer("D2-D1"));

    }

    private Case[] transferer(String saisir) throws Exception {
        String[] divise = saisir.split("[:,-]");
        Case[] position = new Case[2];
        char[] chars = divise[0].toCharArray();
        position[0] = new Case(Echiquier.MAXLIG - (chars[1] - '1') - 1, chars[0] - 'A');

        chars = divise[1].toCharArray();
        position[1] = new Case(Echiquier.MAXLIG - (chars[1] - '1') - 1, chars[0] - 'A');

        return position;
    }

    @Test(expected=Exception.class)
    public void testDeplaceIllegal1() throws Exception{
        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A2-A3"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("A3-A5"));
    }

    @Test(expected=Exception.class)
    ////test bloque en haut
    public void testDeplaceIllegal2() throws Exception{
        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A1-A4"));
    }

    @Test(expected=Exception.class)
    //test bloque bas
    public void testDeplaceIllegal3() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A2-A4"));
        echiquier.deplace(transferer("A8-A6"));

    }

    @Test(expected=Exception.class)
    //test bloque à gauche
    public void testDeplaceIllegal4() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A2-A4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("A1-A3"));
        echiquier.deplace(transferer("A8-A7"));
        echiquier.deplace(transferer("B2-B3"));
        echiquier.deplace(transferer("A3-H3"));

    }

    @Test(expected=Exception.class)
    //test bloque à droit
    public void testDeplaceIllegal5() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A2-A4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("A1-A3"));
        echiquier.deplace(transferer("A8-A6"));
        echiquier.deplace(transferer("A3-B3"));
        echiquier.deplace(transferer("B7-B6"));
        echiquier.deplace(transferer("B3-A3"));
        echiquier.deplace(transferer("A6-D6"));
    }

    @Test(expected=Exception.class)
    //test bloque en haut à gauche
    public void testDeplaceIllegal6() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("C1-A3"));
    }

    @Test(expected=Exception.class)
    //test bloque en haut à droite
    public void testDeplaceIllegal7() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("C1-E4"));
    }

    @Test(expected=Exception.class)
    //test bloque en bas à droite
    public void testDeplaceIllegal8() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("C8-A6"));
    }

    @Test(expected=Exception.class)
    //test bloque en bas à droite
    public void testDeplaceIllegal9() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("C8-F5"));
    }

    @Test(expected=Exception.class)
    //test tour ne peut pas deplacer en diagonales
    public void testDeplaceIllegal10() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A2-A4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("A1-A3"));
        echiquier.deplace(transferer("A5-A4"));
        echiquier.deplace(transferer("A3-C5"));
    }

    @Test(expected=Exception.class)
    //test fou ne peut pas deplacer en ligne
    public void testDeplaceIllegal11() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("C2-C4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("C1-C3"));
    }

    @Test(expected=Exception.class)
    //test fou ne peut pas deplacer en ligne
    public void testDeplaceIllegal12() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("C2-C4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("C1-C3"));
    }

    @Test(expected=Exception.class)
    //test cavalier ne peut pas deplacer en ligne
    public void testDeplaceIllegal13() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("B2-B4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("B1-B3"));
    }

    @Test(expected=Exception.class)
    //test roi ne peut pas deplacer trop
    public void testDeplaceIllegal14() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("E2-E4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("E1-E3"));
    }

    @Test(expected=Exception.class)
    //test roi ne peut pas deplacer trop
    public void testDeplaceIllegal15() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("E2-E4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("E1-E2"));
        echiquier.deplace(transferer("A5-A4"));
        echiquier.deplace(transferer("E2-H5"));
    }

    @Test(expected=Exception.class)
    //test pion ne deplace qu'avance.
    public void testDeplaceIllegal16() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A2-A4"));
        echiquier.deplace(transferer("A7-A5"));
        echiquier.deplace(transferer("A4-A3"));
    }

    @Test(expected=Exception.class)
    //test ne peut pas prise le picec entre même joueur.
    public void testDeplaceIllegal17() throws Exception{

        Echiquier echiquier = new Echiquier();

        echiquier.deplace(transferer("A1-A2"));
    }

}
